<template>
    <div v-show="isCamera">
        <div @click.prevent="onScan" class="btn btn-primary"><i class="icon-qr-scan"></i></div>
        <div class="qrscanner__wrap">
            <div class="qrscanner__overlay" @click="onClose"></div>
            <div class="qrscanner__inner">
                <div id="qrscannerRegion" ref="qrscannerRegion"></div>
                <video id="qrscannerVideo" ref="qrscannerVideo"></video>
            </div>
        </div>
    </div>
</template>

<script>
import QrScanner from 'qr-scanner';
import qrScannerWorkerSource from '!!raw-loader!../../../node_modules/qr-scanner/qr-scanner-worker.min.js';

QrScanner.DEFAULT_CANVAS_SIZE = 200;
QrScanner.WORKER_PATH = URL.createObjectURL(new Blob([qrScannerWorkerSource]));

export default {
    name: "QRScanner",
    data() {
        return {
            qrScanner: null,
            isCamera: false
        }
    },
    mounted() {
        QrScanner.hasCamera().then((hasCamera) => {
            this.isCamera = hasCamera;
            if(hasCamera) {
                this.qrScanner = new QrScanner(this.$refs.qrscannerVideo, this.onScanSuccess);
                this.$refs.qrscannerRegion.appendChild(this.qrScanner.$canvas);
            }
        });
    },
    methods: {
        onScan() {
            this.qrScanner.start();
            document.body.classList.add("qrscanner-open");
        },
        onClose() {
            document.body.classList.remove("qrscanner-open");

            this.qrScanner.stop();

            const context = this.qrScanner.$canvas.getContext('2d');
            context.clearRect(0, 0, this.qrScanner.$canvas.width, this.qrScanner.$canvas.height);
        },
        onScanSuccess(result) {
            this.$emit('result', result);
            this.onClose();
        }
    }
}
</script>

<style lang="scss">
.qrscanner {
    &__wrap {
        visibility: hidden;
        opacity: 0;
        position: fixed;
        top: 0;
        bottom: 0;
        left: 0;
        right: 0;
        display: flex;
        justify-content: center;
        align-items: center;
        z-index: 2000;
    }

    &__overlay {
        position: absolute;
        top: 0;
        bottom: 0;
        left: 0;
        right: 0;
        background: rgba(0, 0, 0, 0.5);
        z-index: 1;
    }

    &__inner {
        background: #fff;
        padding: 15px;
        border-radius: 5px;
        position: relative;
        z-index: 2;
        overflow: hidden;
    }
}

body {
    &.qrscanner-open {
        overflow: hidden;

        .qrscanner {
            &__wrap {
                visibility: visible;
                opacity: 1;
            }
        }
    }
}

#qrscannerRegion {
    canvas {
        display: block;
    }
}

#qrscannerVideo {
    width: 0;
    height: 0;
    position: absolute;
    bottom: 0;
    right: 0;
    /*display: none;
    opacity: 0;
    overflow: hidden;
    visibility: hidden;*/
}
</style>
